package com.dsic.gj_erp.controller.jhgk;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.bean.pgd.DmPpxxb;
import com.dsic.gj_erp.mapper.pgd.DmPpxxbMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.pgd.DmPpxxbService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("ypp")
@AllArgsConstructor
public class YppController {

    private final DmQfxqService qfxqService;
    private final DmPpxxbService ppxxbService;

    private final DmPpxxbMapper ppxxbMapper;

    @PostMapping("getQfxq")
    public ResultBean<?> getQfxq(@RequestBody DmQfxq qfxq){
        String existsSql="select dc_ch,dc_pl,dc_fd from dm_ppxxb ";
        StringBuilder builder=new StringBuilder(existsSql);
        builder.append("where dc_ch=").append("'").append(qfxq.getDcCh()).append("'");
        if (StrUtil.isNotEmpty(qfxq.getDcPl())){
            builder.append(" dc_pl=").append("'").append(qfxq.getDcPl()).append("'");
        }
        if (StrUtil.isNotEmpty(qfxq.getDcFd())){
            builder.append(" dc_fd=").append("'").append(qfxq.getDcFd()).append("'");
        }
        builder.append(" group by dc_ch,dc_pl,dc_fd");
        List<DmQfxq> list = qfxqService.list(Wrappers.<DmQfxq>lambdaQuery()
                .eq(DmQfxq::getDcCh, qfxq.getDcCh())
                .eq(StrUtil.isNotEmpty(qfxq.getDcPl()),DmQfxq::getDcPl, qfxq.getDcPl())
                .eq(StrUtil.isNotEmpty(qfxq.getDcFd()),DmQfxq::getDcFd, qfxq.getDcFd())
                .eq(DmQfxq::getZt,"")
                .notExists(builder.toString())
        );
        return new ResultBean<>(list);
    }

    @PostMapping("getLjxx")
    public ResultBean<?> getLjxx(@RequestBody Map<String,Object> map){
        List<DmYdjhLj> dmYdjhLj = ppxxbMapper.getDmYdjhLj(map);
        return new ResultBean<>(dmYdjhLj);
    }

    @PostMapping("getList")
    public ResultBean<?> getList(@RequestBody DmPpxxb dmPpxxb){
        List<DmPpxxb> list = ppxxbService.list(Wrappers.<DmPpxxb>lambdaQuery()
                .eq(DmPpxxb::getDcCh, dmPpxxb.getDcCh())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDwh()), DmPpxxb::getDwh, dmPpxxb.getDwh())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getQy()), DmPpxxb::getQy, dmPpxxb.getQy())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDcPl()), DmPpxxb::getDcPl, dmPpxxb.getDcPl())
                .eq(StrUtil.isNotEmpty(dmPpxxb.getDcFd()), DmPpxxb::getDcFd, dmPpxxb.getDcFd())
        );

        return new ResultBean<>(list);
    }

    @PostMapping("checkBfwz")
    public ResultBean<?> checkBfwz(@RequestBody List<DmPpxxb> list){

        return new ResultBean<>();
    }
}
